<template>
  <Modal
    :options="getModalOptions"
    :on-close="handleClose"
    :on-positive-click="handleConfirm"
    :on-negative-click="handleClose"
  >
    <template #Context>
      <n-form
        ref="formRef"
        :model="menuForm"
        :rules="menuRules"
        :label-width="80"
        label-placement="left"
        require-mark-placement="left"
        :disabled="disabled"
      >
        <n-grid x-gap="12" :cols="2">
          <template v-for="(item,index) in getFormOptions" :key="index">
            <n-gi>
              <n-form-item :label="item.label" :path="item.key">
                <n-input v-if="item.type === 'input'" v-model:value="menuForm[item.key]" v-bind="item.props" />
                <n-select v-if="item.type === 'select'" v-model:value="menuForm[item.key]" v-bind="item.props" />
                <n-input-number v-if="item.type === 'number'" v-model:value="menuForm[item.key]" v-bind="item.props" />
                <n-radio-group v-if="item.type === 'radio'" v-model:value="menuForm[item.key]" :name="item.key">
                  <n-space>
                    <n-radio v-for="(cItem,cIndex) in item.options" :key="`${item.key}_${cIndex}`" :value="cItem.value"> {{ cItem.label }}</n-radio>
                  </n-space>
                </n-radio-group>
              </n-form-item>
            </n-gi>
          </template>
        </n-grid>

      </n-form>
    </template>
  </Modal>
</template>

<script>
import { form, changeMenuType, getMenuOptions } from '../tools/form.js'
import { defineComponent, ref, reactive, computed, watch, toRefs } from 'vue'
import Modal from '@/components/Modal/index.vue'
import { addMenu, editMenu } from '@/api/system/menu/index.js'
export default defineComponent({
  name: 'MenuModal',
  components: { Modal },
  props: {
    visible: {
      type: Boolean,
      default: false
    },
    type: {
      type: String,
      default: 'create'
    },
    data: {
      type: Object,
      default: () => {}
    }
  },
  emits: {
    'update:visible': null,
    'reload': null
  },
  setup(props, { emit }) {
    const MODAL_TYPE = {
      'create': '新建菜单',
      'preview': '菜单详情',
      'update': '编辑菜单'
    }
    getMenuOptions()
    const { menuForm, menuRules } = form
    const formRef = ref()
    const data = reactive({
      menuForm: {
        ...menuForm,
        ...props.data,
        pid: props.data?.pid === 0 ? null : props.data?.pid
      },
      menuRules: {
        ...menuRules
      },
      disabled: props.type === 'preview'
    })

    watch(() => data.menuForm.type,
      (val) => {
        switch (val) {
          case 0:
            data.menuForm.permission = ''
            break
          case 1:
            data.menuForm.path = ''
            data.menuForm.component = ''
            break
        }
        changeMenuType(val)
      })

    const getModalOptions = computed(() => {
      return {
        title: MODAL_TYPE[props.type],
        show: props.visible,
        negativeText: '取消',
        positiveText: '确认'
      }
    })

    const getFormOptions = computed(() => {
      console.log('change')
      return {
        ...form.formItem
      }
    })

    function handleConfirm() {
      formRef.value.validate((errors) => {
        if (!errors) {
          const params = { ...data.menuForm }
          if (params.id) {
            editMenu(params).then(res => {
              if (res.code === 0) {
                emit('reload')
                handleClose()
              }
            }).catch(e => {
              console.log(e)
            })
          } else {
            addMenu(params).then(res => {
              if (res.code === 0) {
                emit('reload')
                handleClose()
              }
            })
          }
        } else {
          $message.error('请完善必填信息')
        }
      })
    }

    /* 关闭弹窗 */
    const handleClose = () => {
      emit('update:visible', false)
    }

    return {
      ...toRefs(data),
      formRef,
      getModalOptions,
      getFormOptions,
      handleConfirm,
      handleClose
    }
  }
})
</script>
<style scoped lang='scss'>
</style>
